/*
 ****************************************************************************
 *
 *                   "DHRYSTONE" Benchmark Program
 *                   -----------------------------
 *                                                                            
 *  Version:    C, Version 2.0
 *                                                                            
 *  File:       dhry_pack_1.c (part 2 of 3)
 *
 *  Date:       March 3, 1988
 *
 *  Author:     Reinhold P. Weicker
 *
 ****************************************************************************
 */

#include "dhry_glo.h"

/*
 *	Global Variables:
 */
Rec_Pointer    *Ptr_Glob,
	       *Next_Ptr_Glob;
int     	Int_Glob;
Boolean 	Bool_Glob;
char    	Ch_1_Glob,
        	Ch_2_Glob;
int     	Ar_1_Glob[50];
int     	Ar_2_Glob[50][50];
char		System_Type[80];
char		Compiler_Type[80];

/*
 *	forward declaration necessary since Enumeration may not simply be int
 */
extern char    *malloc ();
Enumeration	Func_1 ();

#ifndef REG
Boolean 	Reg = false;		/* REG becomes defined as empty */
#define REG				/* i.e. no register variables   */
#else
Boolean 	Reg = true;
#endif

/*
 *	variables for time measurement:
 */
#ifdef TIMES
struct tms      time_info;
extern int      times ();		/* see library function "times" */
#endif
#ifdef TIME
extern long     time ();		/* see library function "time"  */
#endif

#define Too_Small_Time	2		/* Measurements should last at least 2
					   seconds */

long    	Begin_Time,
	        End_Time,
        	User_Time;
float   	Microseconds,
	        Dhrystones_Per_Second;



main (argc, argv)
int     argc;
char   *argv[];
{

/*
 *	main program, corresponds to procedures Main and Proc_0 in the
 *	Ada version
 */

	One_Fifty	Int_1_Loc;
	REG One_Fifty 	Int_2_Loc;
	One_Fifty 	Int_3_Loc;
	REG char        Ch_Index;
	Enumeration 	Enum_Loc;
	Str_30 		Str_1_Loc[31];
	Str_30 		Str_2_Loc[31];
	REG int 	Run_Index;
	REG int 	Number_Of_Runs;
	long    	dum = 0L;


	/*
	 *   Initializations
	 */
	Next_Ptr_Glob = (Rec_Pointer *) malloc (sizeof (Rec_Type));
	Ptr_Glob      = (Rec_Pointer *) malloc (sizeof (Rec_Type));

	Ptr_Glob->Ptr_Comp                = Next_Ptr_Glob;
	Ptr_Glob->Discr                   = Ident_1;
	Ptr_Glob->variant.var_1.Enum_Comp = Ident_3;
	Ptr_Glob->variant.var_1.Int_Comp  = 40;
	strcpy (Ptr_Glob->variant.var_1.Str_Comp,
			"DHRYSTONE PROGRAM, SOME STRING");
	strcpy (Str_1_Loc, "DHRYSTONE PROGRAM, 1\'ST STRING");
	strcpy (System_Type, SYSTYPE);
	strcpy (Compiler_Type, COMPTYPE);

	/*
	 *   Was missing in published program. Without this
	 *   initialization, Ar_2_Glob [8][7] would have an
	 *   undefined value.
	 *   Warning: With 16-Bit processors and Number_Of_Runs > 32000,
	 *   overflow may occur for this array element.
	 */
	Ar_2_Glob[8][7] = 10;

	printf ("\n");
	printf ("Dhrystone Benchmark, Version 2.0 (Language: C)\n");
	printf ("\n");
	printf ("System:   %s\n", System_Type);
	printf ("Compiler: %s\n", Compiler_Type);
	printf ("\n");
	if (Reg)
	{
		printf ("Program compiled with 'register' attribute\n");
	}
	else
	{
		printf ("Program compiled without 'register' attribute\n");
	}
	printf ("\n");
	{
		int	n;

		if (argc > 1)
		{
			n = atoi (argv[1]);
		}
		else
		{
#ifdef ALCYON
			/*
			 *   stupid alcyon scanf(3) is bad
			 */
			n = 5000;
#else
			printf ("Please give the number of runs through the benchmark: ");
			scanf ("%d", &n);
#endif
		}
		Number_Of_Runs = n;
	}
	printf ("\n");

	printf ("Execution starts, %d runs through Dhrystone\n", Number_Of_Runs);


	/*
	 *   Start timer
	 */
#ifdef TIMES
	times (&time_info);
	Begin_Time = (long) time_info.tms_utime;
#endif
#ifdef TIME
	dum = (long) 0;
	Begin_Time = time (&dum);
#endif

	for (Run_Index = 1; Run_Index <= Number_Of_Runs; ++Run_Index)
	{
		/*
		 *   Ch_1_Glob == 'A', Ch_2_Glob == 'B', Bool_Glob == true
		 */
		Proc_5 ();
		Proc_4 ();

		Int_1_Loc = 2;
		Int_2_Loc = 3;
		strcpy (Str_2_Loc, "DHRYSTONE PROGRAM, 2'ND STRING");
		Enum_Loc  = Ident_2;

		/*
		 *   Bool_Glob == 1
		 */
		Bool_Glob = !Func_2 (Str_1_Loc, Str_2_Loc);
		while (Int_1_Loc < Int_2_Loc)/* loop body executed once */
		{
			/*
			 *   Int_3_Loc == 7
			 */
			Int_3_Loc = 5 * Int_1_Loc - Int_2_Loc;
			Proc_7 (Int_1_Loc, Int_2_Loc, &Int_3_Loc);
			Int_1_Loc += 1;
		}
		/*
		 *   Int_1_Loc == 3, Int_2_Loc == 3, Int_3_Loc == 7
		 */
		Proc_8 (Ar_1_Glob, Ar_2_Glob, Int_1_Loc, Int_3_Loc);

		/*
		 *   Int_Glob == 5
		 */
		Proc_1 (Ptr_Glob);
		for (Ch_Index = 'A'; Ch_Index <= Ch_2_Glob; ++Ch_Index)
		{
			/*
			 *   loop body executed twice
			 */
			if (Enum_Loc == Func_1 (Ch_Index, 'C'))
			{
				/*
				 *   then, not executed
				 */
				Proc_6 (Ident_1, &Enum_Loc);
				strcpy (Str_2_Loc, "DHRYSTONE PROGRAM, 3'RD STRING");
				Int_2_Loc = Run_Index;
				Int_Glob = Run_Index;
			}
		}
		/*
		 *   Int_1_Loc == 3, Int_2_Loc == 3, Int_3_Loc == 7
		 */
		Int_2_Loc = Int_2_Loc * Int_1_Loc;
		Int_1_Loc = Int_2_Loc / Int_3_Loc;
		Int_2_Loc = 7 * (Int_2_Loc - Int_3_Loc) - Int_1_Loc;
		/*
		 *   Int_1_Loc == 1, Int_2_Loc == 13, Int_3_Loc == 7
		 */
		Proc_2 (&Int_1_Loc);
		/*
		 *   Int_1_Loc == 5
		 */

	}

	/*
	 *   Stop timer
	 */
#ifdef TIMES
	times (&time_info);
	End_Time = (long) time_info.tms_utime;
#endif
#ifdef TIME
	dum = (long) 0;
	End_Time = time (&dum);
#endif

	printf ("Execution ends\n");
	printf ("\n");
	printf ("Final values of the variables used in the benchmark:\n");
	printf ("\n");
	printf ("Int_Glob:            %d\n", Int_Glob);
	printf ("        should be:   %d\n", 5);
	printf ("Bool_Glob:           %d\n", Bool_Glob);
	printf ("        should be:   %d\n", 1);
	printf ("Ch_1_Glob:           %c\n", Ch_1_Glob);
	printf ("        should be:   %c\n", 'A');
	printf ("Ch_2_Glob:           %c\n", Ch_2_Glob);
	printf ("        should be:   %c\n", 'B');
	printf ("Ar_1_Glob[8]:        %d\n", Ar_1_Glob[8]);
	printf ("        should be:   %d\n", 7);
	printf ("Ar_2_Glob[8][7]:     %d\n", Ar_2_Glob[8][7]);
	printf ("        should be:   Number_Of_Runs + 10\n");
	printf ("Ptr_Glob->\n");
	printf ("  Ptr_Comp:          %d\n", (int) Ptr_Glob->Ptr_Comp);
	printf ("        should be:   (implementation-dependent)\n");
	printf ("  Discr:             %d\n", Ptr_Glob->Discr);
	printf ("        should be:   %d\n", 0);
	printf ("  Enum_Comp:         %d\n", Ptr_Glob->variant.var_1.Enum_Comp);
	printf ("        should be:   %d\n", 2);
	printf ("  Int_Comp:          %d\n", Ptr_Glob->variant.var_1.Int_Comp);
	printf ("        should be:   %d\n", 17);
	printf ("  Str_Comp:          %s\n", Ptr_Glob->variant.var_1.Str_Comp);
	printf ("        should be:   DHRYSTONE PROGRAM, SOME STRING\n");
	printf ("Next_Ptr_Glob->\n");
	printf ("  Ptr_Comp:          %d\n", (int) Next_Ptr_Glob->Ptr_Comp);
	printf ("        should be:   (implementation-dependent), same as above\n");
	printf ("  Discr:             %d\n", Next_Ptr_Glob->Discr);
	printf ("        should be:   %d\n", 0);
	printf ("  Enum_Comp:         %d\n", Next_Ptr_Glob->variant.var_1.Enum_Comp);
	printf ("        should be:   %d\n", 1);
	printf ("  Int_Comp:          %d\n", Next_Ptr_Glob->variant.var_1.Int_Comp);
	printf ("        should be:   %d\n", 18);
	printf ("  Str_Comp:          %s\n",
			Next_Ptr_Glob->variant.var_1.Str_Comp);
	printf ("        should be:   DHRYSTONE PROGRAM, SOME STRING\n");
	printf ("Int_1_Loc:           %d\n", Int_1_Loc);
	printf ("        should be:   %d\n", 5);
	printf ("Int_2_Loc:           %d\n", Int_2_Loc);
	printf ("        should be:   %d\n", 13);
	printf ("Int_3_Loc:           %d\n", Int_3_Loc);
	printf ("        should be:   %d\n", 7);
	printf ("Enum_Loc:            %d\n", Enum_Loc);
	printf ("        should be:   %d\n", 1);
	printf ("Str_1_Loc:           %s\n", Str_1_Loc);
	printf ("        should be:   DHRYSTONE PROGRAM, 1'ST STRING\n");
	printf ("Str_2_Loc:           %s\n", Str_2_Loc);
	printf ("        should be:   DHRYSTONE PROGRAM, 2'ND STRING\n");
	printf ("\n");

	User_Time = End_Time - Begin_Time;

	if (User_Time < Too_Small_Time)
	{
		printf ("Measured time too small to obtain meaningful results\n");
		printf ("Please increase number of runs\n");
		printf ("\n");
	}
	else
	{
#ifdef TIME
		Microseconds          = (float) User_Time * Usec_Per_Second
					/ (float) Number_Of_Runs;
		Dhrystones_Per_Second = (float) Number_Of_Runs
					/ (float) User_Time;
#else
		Microseconds          = (float) User_Time * Usec_Per_Second
					/ ((float) HZ * ((float) Number_Of_Runs));
		Dhrystones_Per_Second = ((float) HZ * (float) Number_Of_Runs)
					/ (float) User_Time;
#endif
		printf ("Microseconds for one run through Dhrystone: ");
		printf ("%6.1f \n", Microseconds);
		printf ("Dhrystones per Second:                      ");
		printf ("%6.1f \n", Dhrystones_Per_Second);
		printf ("\n");
	}


	exit (0);
}


Proc_1 (Ptr_Val_Par)			/* executed once */
REG Rec_Pointer *Ptr_Val_Par;
{
	/*
	 *   Local variable, initialized with Ptr_Val_Par->Ptr_Comp,
	 *   corresponds to "rename" in Ada, "with" in Pascal
	 */
	REG Rec_Pointer	*Next_Record = Ptr_Val_Par->Ptr_Comp;	/* == Ptr_Glob_Next */

	str_asgn (*Ptr_Val_Par->Ptr_Comp, *Ptr_Glob);
	Ptr_Val_Par->variant.var_1.Int_Comp = 5;
	Next_Record->variant.var_1.Int_Comp
		= Ptr_Val_Par->variant.var_1.Int_Comp;
	Next_Record->Ptr_Comp = Ptr_Val_Par->Ptr_Comp;
	Proc_3 (&(Next_Record->Ptr_Comp));
	/*
	 *   Ptr_Val_Par->Ptr_Comp->Ptr_Comp == Ptr_Glob->Ptr_Comp
	 */
	if (Next_Record->Discr == Ident_1)
	{
		/*
		 *   then, executed
		 */
		Next_Record->variant.var_1.Int_Comp = 6;
		Proc_6 (Ptr_Val_Par->variant.var_1.Enum_Comp,
				&Next_Record->variant.var_1.Enum_Comp);
		Next_Record->Ptr_Comp = Ptr_Glob->Ptr_Comp;
		Proc_7 (Next_Record->variant.var_1.Int_Comp, 10,
				&Next_Record->variant.var_1.Int_Comp);
	}
	else
		/*
		 *   not executed
		 */
		str_asgn (*Ptr_Val_Par, *Ptr_Val_Par->Ptr_Comp);
}


Proc_2 (Int_Par_Ref)			/* executed once */
One_Fifty      *Int_Par_Ref;		/* *Int_Par_Ref == 1, becomes 4 */
{
	One_Fifty	Int_Loc;
	Enumeration 	Enum_Loc;

	Int_Loc = *Int_Par_Ref + 10;
	do
	{
		/*
		 *   executed once
		 */
		if (Ch_1_Glob == 'A')
		{
			/*
			 *   then, executed
			 */
			Int_Loc -= 1;
			*Int_Par_Ref = Int_Loc - Int_Glob;
			Enum_Loc = Ident_1;
		}

	} while (Enum_Loc != Ident_1);	/* true */
}


Proc_3 (Ptr_Ref_Par)			/* executed once */
Rec_Pointer **Ptr_Ref_Par;		/* Ptr_Ref_Par becomes Ptr_Glob */
{
	if (Ptr_Glob != Null)
		/*
		 *   then, executed
		 */
		*Ptr_Ref_Par = Ptr_Glob->Ptr_Comp;
	else
		/*
		 *   not executed
		 */
		Int_Glob = 100;

	Proc_7 (10, Int_Glob, &Ptr_Glob->variant.var_1.Int_Comp);
}



Proc_4 ()				/* executed once */
{
	Boolean Bool_Loc;

	Bool_Loc = Ch_1_Glob == 'A';
	Bool_Glob = Bool_Loc | Bool_Glob;
	Ch_2_Glob = 'B';
}


Proc_5 ()				/* executed once */
{
	Ch_1_Glob = 'A';
	Bool_Glob = false;
}


#ifdef  NOSTRUCTASSIGN
/*
 *   Procedure for the assignment of structures,
 *   if the C compiler doesn't support this feature
 */
memcpy (d, s, l)
register char  *d;
register char  *s;
register int    l;
{
	while (l--)
		*d++ = *s++;
}
#endif
